@ECHO OFF
chcp 650001
SETLOCAL
echo "** GERANDO CERTIFICADO PARA O SICREDI **"
echo %~dp0
REM Desenvolvido por L2 SOLCUOES TECNOLOGICAS LTDA
set BASE_DIR=%~dp0

REM FIXO
set OPENSSL_CONF=%BASE_DIR%\BIN\openssl.cnf
set OPENSSL=%BASE_DIR%\BIN\openssl.exe
set PATH=%BASE_DIR%\BIN\;%PATH%


REM Variaveis informada pelo usuário
set NOME=
set SENHA=
set EMAIL=

set /P NOME="Digite o NOME da ENTIDADE: "
IF "%NOME%" == "" GOTO USOINCORRETO

set /P SENHA="Digite o SENHA do CERTIFICADO: "
IF "%SENHA%" == "" GOTO USOINCORRETO

set KEYFILE=%~dp0CERTIFICADOS\%NOME%.key
set CERFILE=%~dp0CERTIFICADOS\%NOME%.cer
set PFXFILE=%~dp0CERTIFICADOS\%NOME%.pfx
set CSRFILE=%~dp0CERTIFICADOS\%NOME%.csr
echo ""
echo ===============================================================================================================================================
echo Chave privada (*.KEY)            : %KEYFILE%
echo Solicitacao de assinatura (*.CSR): %CSRFILE%
echo Certificado (*.CER)              : %CERFILE%
echo ===============================================================================================================================================
echo ""

REM Comandos
:MENU
set COMANDO=
echo Digite uma das opções:
echo " 'CSR' - para gerar a chave (*.KEY) e a requisição de assinatura (*.CSR);"
echo " 'PFX' - Para gerar converter o *.CER + *.KEY em *.PFX;"
echo " 'FIM' - Para sair deste programa."
set /P COMANDO="Digite CSR, PFX ou FIM para prosseguir: "
IF "%COMANDO%" == "CSR" GOTO GERARCSR
IF "%COMANDO%" == "PFX" GOTO GERARPFX
IF "%COMANDO%" == "FIM" GOTO FIM
GOTO USOINCORRETO

:GERARCSR
echo Gerando o KEY e CSR...
IF EXIST %KEYFILE% (
  echo Arquivo %KEYFILE% já existe. Não pode ser recriado. Se necessário remova-o manualmente.
  GOTO MENU
)
set /P EMAIL="Digite o EMAIL da ENTIDADE: "
IF "%EMAIL%" == "" GOTO USOINCORRETO


REM %OPENSSL% genrsa -out %NOME%.key 2048 -passout pass:%SENHA%
%OPENSSL% req -new -subj "/emailAddress=%EMAIL%/CN=api-pix-%NOME%/OU=API PIX Sicredi/organizationName=Confederacao Interestadual das Cooperativas Ligadas ao Sicredi/L=Porto Alegre/ST=Rio Grande do Sul/C=BR" -out %CSRFILE% -nodes -sha512 -newkey rsa:2048 -keyout %KEYFILE% -passout pass:%SENHA%
echo Chave privada gerada: %KEYFILE%
echo CSR gerado: %CSRFILE%, envie este arquivo para o banco.

GOTO MENU


:GERARPFX
IF "%NOME%" == "" (
	set /P NOME="Digite o NOME da ENTIDADE: "
	IF "%NOME%" == "" GOTO USOINCORRETO

	set /P SENHA="Digite o SENHA do CERTIFICADO: "
	IF "%SENHA%" == "" GOTO USOINCORRETO
)
IF EXIST %KEYFILE% (
  GOTO VERIFICACER
)
ECHO "Arquivo KEY não encontrado: %KEYFILE%.
timeout /t 30
GOTO MENU

:VERIFICACER
IF EXIST %CERFILE% (
  GOTO CRIARPFX
)

echo Arquivo %CERFILE% não encontrado. Copie o arquivo para o local indicado e tente novamente.
timeout /t 30
GOTO MENU

:CRIARPFX
echo Gerando o PFX...
%OPENSSL% pkcs12 -export -passin pass:%SENHA% -in %CERFILE% -inkey %KEYFILE% -out %PFXFILE% -passout pass:%SENHA%

echo Arquivo PFX gerado em: %PFXFILE%
GOTO FIM

:USOINCORRETO
echo "Dados incorretos."
timeout /t 60
GOTO MENU

:FIM
ECHO "FIM!"
timeout /t 90